/*
Mike Morris and Karl Frinkle, Southeastern Oklahoma State University
Last Modified: 2012.09.25

This program will generate two square matrices of size n (below)
Process 0 will generate An.bin, and process 1 will generate Bn.bin.
The entries will be integer entries between -10 and 10. 

*/


#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <mpi.h>
#include <memory.h>


int main(int argc, char** argv)
{
	int n = 100*100; //The number of entries in the matrices to
		   //multiply together

	int my_rank, world_size, destination, tag, source, length;
	int *buf;
	int err=0;
	char message[8], name[80];

	char line[80];
	int j=0;
	int seed;
	double temp;
	int rand1;
	int randval;

	char fnameA[] = "A100.bin"; //number should be sqrt(n) on these
	char fnameB[] = "B100.bin";

	MPI_Status status;
	MPI_File fpB;
	MPI_File fpA;

	MPI_Init(&argc, &argv); /* note that argc and argv are passed by address */
	
	MPI_Comm_rank(MPI_COMM_WORLD,&my_rank);
	MPI_Comm_size(MPI_COMM_WORLD,&world_size);

	buf = (int *)malloc(n*sizeof(int));
	MPI_File_open(MPI_COMM_WORLD, fnameA, MPI_MODE_RDWR | MPI_MODE_CREATE, MPI_INFO_NULL, &fpA);	
	MPI_File_open(MPI_COMM_WORLD, fnameB, MPI_MODE_RDWR | MPI_MODE_CREATE, MPI_INFO_NULL, &fpB);
	
	if(my_rank == 0){
		seed = (my_rank+1)*time(NULL);
		srand(seed);
		for(j=0; j<n; j++){
			rand1 = rand();
			temp = (double)rand1/(double)RAND_MAX;
			buf[0] = -10+20*temp;
			if(j==2) buf[0] = 30;
			printf("from node %d, the value %d is %d\n", my_rank, j, buf[0]);
			MPI_File_write(fpA, buf, 1, MPI_INT, &status); //buf is the address of buf[0];
		}
	}

	if(my_rank == 1){
		seed = (my_rank+1)*time(NULL);
		srand(seed);
//		if(err != MPI_SUCCESS) printf("Greetings from node %d with error of %d\n", my_rank, err);
		for(j=0; j<n; j++){
			rand1 = rand();
			temp = (double)rand1/(double)RAND_MAX;
			buf[0] = -10+20*temp;
			if(j==2) buf[0] = -20;
			printf("from node %d, the value %d is %d\n", my_rank, j, buf[0]);
			MPI_File_write(fpB, buf, 1, MPI_INT, &status);
		}				
	}
	MPI_File_close(&fpB);
	MPI_File_close(&fpA);
	MPI_Finalize();
}
