/*
Mike Morris and Karl Frinkle, Southeastern Oklahoma State University
Last Modified: 2012.01.29

This program will generate an ASCII text file which contains a matrix in row/column form.  The first
argument will be the name of the matrix, A, B, or C, while the second should be a positive integer
equal to the square dimension of the desired matrix.  You should be able to edit this matrix text file
directly after generation.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

int Err_Func(char * msg)
{
	printf("\nError: %s\n", msg);
	printf("Required use: ./matrix_generator_ASCII A n   where 'A' is matrix name, 'n' is size.\n");
	printf("Use 'A', 'B' or 'C' for matrix name, any integer (don't use commas) for 'n'.\n\n");
	return 1;
}

int main(int num, char * items[])
{
if (num == 1)
	return Err_Func("Use parameters in command line.\n");

if (num == 2)
	return Err_Func("Parameter missing in command line.\n");

if (num > 3)
	return Err_Func("Too many parameters in command line.\n");

//num = 3  Just right!
if ((items[1][0] != 'A') && (items[1][0] != 'B') && (items[1][0] != 'C'))
	return Err_Func("Unacceptible name.\n");

int size;
size = atoi(items[2]);
printf("Size = %d.\n", size);
if (size == 0)
	return Err_Func("Size should be an integer less than 3 zillion.\n");

//Everything's cool - build filename.
char fileName[80];
strcpy(fileName, "");
strcat(fileName, items[1]);
strcat(fileName, items[2]);
strcat(fileName, ".txt");
printf("File = %s.\n", fileName);

//create file
int randval = 0;
int rand1 = 0;
double temp = 0.0;
int seed = time(NULL);
srand(seed);

FILE *fp;
fp = fopen(fileName, "w");

if (!fp)
	return Err_Func("File open failed - call Karl.\n");

//write size-squared records to the file
double rec = 0.0;
while (rec < (double)size * (double)size)
{
	rand1 = rand();
//	printf("%d   %d\n", rand1, RAND_MAX);
	temp = (double)rand1/(double)RAND_MAX;
	randval = -10 + 20 * temp;
	fprintf(fp, "%d ", randval);
	rec = rec + 1.0;
	if ((int)rec % (size) == 0)
		fprintf(fp, "\n"); 
}

fclose(fp);

return 0;
}

