/*
Mike Morris and Karl Frinkle, Southeastern Oklahoma State University
Last Modified: 2011.12.19

This program will read a binary matrix file of the form An.bin, where n is a positive integer.  Be sure
to make sure that the file exists, and is in binary form.  There is a wonderful built in menu to look
at ranges of entries for large matrices which may be too large to display in full.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int Err_Func(char * msg)
{
	printf("\nError: %s\n", msg);
	printf("Required use: ./bread filename where 'filename' is - what else - your file's name!\n");
	return 1;
}

char menu(char *, int);

int main(int num, char * items[])
{
if (num == 1)
	return Err_Func("Use parameters in command line.\n");

if (num > 2)
	return Err_Func("Too many parameters in command line.\n");

//num = 2  Just right!

int size, element, rec, i, stopper;
int start, end;
char choice = '1';
char s;

char fileName[80];
strcpy(fileName, items[1]);
printf("File name is %s.\n", fileName);

FILE *fp;
fp = fopen(fileName, "rb");

if (!fp)
	return Err_Func("File open failed - call Karl.\n");

//determine file size as number of records
int pos = 0;
while (!feof(fp))
{
	fseek(fp, pos, 0);
	fread(&element, 4, 1, fp);
	pos = pos + 4;
}
size = (pos-1) / 4;
printf("File contains %d numbers.\n", size);

//meat of program
while ((choice != 'x') && (choice != 'X'))
{
	system("clear");
	printf("MAIN MENU - examine file: \"%s\" that has %d records.\n\n", fileName, size);
	printf("  1. Display entire contents of file.\n");
	printf("  2. Specify a single record's value to display.\n");
	printf("  3. Specify a range of record values to display.\n");
	printf("  X. Exit.\n\n");
	printf("Enter selection: ");
	choice = getchar();
	fflush(stdin);

	switch (choice) {
		case '1': //display entire file
			system("clear");
			getchar();
			printf("Values within \"%s\" that has %d records.\n\n", fileName, size);
			for(pos = 0; pos < size * 4; pos+=4) {
				fseek(fp, pos, 0);
				fread(&element, 4, 1, fp);
				printf("  Record %d of %d = %d\n", pos/4 + 1, size, element);
				if ((pos/4 + 1) % 20 == 0) {
					printf("\nPress Enter to continue or 'X' to exit: ");
					stopper = 0;
					while (stopper == 0) {
						s = getchar();
						if ((s == 'X') || (s == 'x')) {
							pos = size * 4;
							system("clear");
						}
						if (s == '\n') 
							stopper = 1;
					}
					if (pos != size * 4) {
						system("clear");
						printf("Values within \"%s\" that has %d records.\n\n", fileName, size);
					}
				}
			}
			printf("\nPress Enter to continue: ");
			getchar();
			break;
		case '2': //display a single record's value
			system("clear");
			fflush(stdin);
			printf("Values within \"%s\" that has %d records.\n\n", fileName, size);
			printf("Enter the record that you wish to examine: ");
			scanf(" %d", &rec);
			while(getchar() != '\n') ;
			while ((rec < 0) || (rec > size-1)) {
				rec = 0;
				printf("Your choice should be between 0 and %d. Try again.\n", size-1);
				fflush(stdin);
				scanf("Enter the record that you wish to examine: %d", &rec);
			}
			fseek(fp, rec * 4, 0);
			fread(&element, 4, 1, fp);
			printf("\nRecord %d contains the value %d.\n\n", rec, element);
			printf("Press Enter to continue or CTRL-z to exit: ");
			while(getchar() != '\n') ;
			break;
		case '3': //display a range of record values
			system("clear");
			fflush(stdin);
			printf("Values within \"%s\" that has %d records.\n\n", fileName, size);
			printf("Enter starting & ending record nuumbers, separated by a space: ");
			scanf(" %d %d", &start, &end);
			getchar();
			i = 0;
			if (start > end)
				end = start;
			for(pos = (start-1)*4; pos < end*4; pos+=4) {
				fseek(fp, pos, 0);
				fread(&element, 4, 1, fp);
				i++;
				printf("  Record %d of %d = %d\n", pos/4 + 1, size, element);
				if (i ==20) {
					i = 0;
					printf("\nPress Enter to continue or 'X' to exit: ");
					stopper = 0;
					while (stopper == 0) {
						s = getchar();
						if ((s == 'X') || (s == 'x')) {
							pos = size * 4;
							system("clear");
						}
						if (s == '\n') 
							stopper = 1;
					}
					if (pos != size * 4) {
						system("clear");
						printf("Values within \"%s\" that has %d records.\n\n", fileName, size);
					}
				}
			}
			printf("\nPress Enter to continue: ");
			while(getchar() != '\n') ;
			break;
		case 'X':
		case 'x':
			system("clear");
			exit(0);
			break;
	}

}//end while

fclose(fp);

return 0;
}

char menu(char * f, int s)
{
	char c;
	system("clear");
	printf("MAIN MENU - examine file: \"%s\" that has %d records.\n\n", f, s);
	printf("  1. Display entire contents of file.\n");
	printf("  2. Specify a single record's value to display.\n");
	printf("  3. Specify a range of record values to display.\n");
	printf("  X. Exit.\n\n");
	printf("Enter selection: ");
	c = getchar();
	return c;
}
