/*
Mike Morris and Karl Frinkle, Southeastern Oklahoma State University
Last Modified: 2011.11.14

This program will compute the product of two square matrices
of the same size, and store the result in a new text file.
Each matrix should be stored in a txt file, with one entry
per row, 5 characters per row.  The program MatrixGenerator5L
will create random matrices and store them in txt files
with the restrictions needed to run this program

There will be three file read/writes, fpA and fpB point to the
location of the matrices A and B to be multiplied together.
fpC is the location of the result of A*B, which we call C.

*/
#include <stdio.h>
#include <math.h>

	FILE *fpA, *fpB, *fpC;

int main()
{
	int n = 9; //The number of entries in the matrices to
		   //multiply together
	int N = sqrt(n); //gives the number of rows/columns
	
	int c, r, s, k;

	fpA = fopen("A9.txt", "rt"); //open matrix A, random access

	fpB = fopen("B9.txt", "rt"); //open matrix B, random access

	fpC = fopen("C9.txt", "w"); //open matrix C, random access
	int rowIdx = 0; //index of the row, default to zero before loop
	int colIdx = 0; //index of the row, default to zero before loop
	int a = 0;
	int b = 0;
	int acc = 0; //accumulation of multiplcation of row r of A by column c of B
	
	for(k=0; k<n; k++){
		acc=0;
		c = fmod(k, N)+1;
		r = floor(k/N)+1;
		
		for(s=0; s<N; s++){
		
			rowIdx = (s+(r-1)*N)*(6);
			colIdx = (s*N+(c-1))*(6);
			fseek(fpA, rowIdx, 0);
			fscanf(fpA, "%d", &a);
			fseek(fpB, colIdx, 0);
			fscanf(fpB, "%d", &b);
//			printf("%d %d \n", a, b);
			acc = acc + a * b;
		}
		fprintf(fpC, "%d\n", acc);
	}
		
	fclose(fpA);
	fclose(fpB);
	fclose(fpC);

	printf("\n\n");
}
